package haskell.data.test;

import haskell.data.*;
import java.util.*;

import static haskell.data.Iterables.*;

public class SimpleTests{
  public static <A> List<A> mkList(A... as){
    List<A> result = new LinkedList<A>();
    for (A a:as) result.add(a);
    return result;
  }


  public static void main(String[] args){
    Iterable<String> xs 
    = mkList("hallo","welt","dieses","ist","ein","Test","wie","geht","es","dir");
    System.out.println(xs);	
    System.out.println(take(5,repeat("hallo")));

    UTuple2<String>  ut = new UTuple2<>("hello","world");
    ut
     .filter((x)->x.startsWith("hel"))
     .map((x)->">>>"+x)
     .forEach((String x)->{System.out.println(x.toUpperCase());});


    System.out.println(qsort(xs));
    System.out.println(drop(2,take(5,zip(tail(qsort(xs)),xs))));
    System.out.println(foldl((x,y)->x+y,xs));

    System.out.println(take(5,repeat("hallo")));
    System.out.println(take(5,iterate((x)->x*x,2)));
    System.out.println(take(15,iterate((x)->x+1,1)));
    
    System.out.println(take(5,make(repeat(xs).map((ys)->cons(foldl((x,y)->x+" "+y,ys),new Nil<>())))));

    System.out.println(all((x)->x.length()<10,xs));
    System.out.println(any((x)->x.equals("Test"),xs));
    System.out.println(all((x)->x.length()<5,xs));
    System.out.println(any((x)->x.equals("Test7"),xs));

    Iterable<String> ys = tail(xs);
    System.out.println(ys.getFirst());
    System.out.println(ys.getFirst());
    System.out.println(ys.getFirst());
    
    UTuple2<Iterable<String>> rek = partition((x)->x.length()>3,xs);
    System.out.println(rek.e1);
    System.out.println(rek.e2);	
    System.out.println(reverse(xs));
    System.out.println(intersperse(" +  ",xs));

    System.out.println(intercalate(xs,take(5,repeat(xs))));
    System.out.println(insert("k",qsort(xs)));
    System.out.println(insert((x,y)->x.length()-y.length(),"****",qsort((x,y)->x.length()-y.length(),xs)));
    System.out.println(maximum(xs));

    Iterable<String> abc = mkList("a","b","c");
    System.out.println(subsequences(abc));

    Iterable<Character> zs = mkStringIter("   Hello   World!   ");
    System.out.println(zs);
    System.out.println(drop(6,zs));
    System.out.println(takeWhile(Character::isWhitespace,zs));
    System.out.println(dropWhile(Character::isWhitespace,zs));
    Iterable<Character> dzs = dropWhileEnd(Character::isWhitespace,zs);
    System.out.println(dzs);
    System.out.println(dzs.isEmpty());
    System.out.println(dzs);
    System.out.println(length(dzs));
    System.out.println(dzs);
    System.out.println(init(dzs));
    System.out.println(zs);
    System.out.println(init(xs));
    System.out.println(span(Character::isWhitespace,zs));
    System.out.println(breakIt(Character::isWhitespace,zs));
    System.out.println(stripPrefix(take(7,zs),zs));
    System.out.println(stripPrefix(zs,take(7,zs)));
    System.out.println(group(mkStringIter("Mississippi")));
    System.out.println(inits(mkStringIter("abc")));
    System.out.println(tails(mkStringIter("abc")));
    System.out.println(isPrefixOf(take(7,zs),zs));
    System.out.println(isPrefixOf(zs,take(7,zs)));
    System.out.println(isSuffixOf(drop(7,zs),zs));
    System.out.println(isSuffixOf(zs,drop(7,zs)));
    System.out.println(isInfixOf(mkStringIter("Haskell"),mkStringIter("I really like Haskell.")));
    System.out.println(isInfixOf(mkStringIter("Ial"),mkStringIter("I really like Haskell.")));
    System.out.println(lines("sfdsd\nghjg\nhghj\n\nU"));
    System.out.println(words("  eins    zwei     drei       \n\tvier\n\n"));
    System.out.println(unlines(lines("sfdsd\nghjg\nhghj\n\nU")));
    System.out.println(unwords(words("  eins    zwei     drei       \n\tvier\n\n")));
    System.out.println(nub(mkStringIter("  eins    zwei     drei       vier")));
    System.out.println(union(nub(mkStringIter("  eins    zwei     drei       vier")),mkStringIter("tzufgf")));
    System.out.println(intersect(nub(mkStringIter("  eins    zwei     drei       vier")),mkStringIter("vier8657576")));

    //    System.out.println(fileIterable("mini.txt"));
     
    System.out.println(nub(fileIterable("haskellPrelude/src/haskell/data/test/SimpleTests.java")));

    System.out.println(permutations(mkStringIter("abc")));
    System.out.println(permutations2(mkStringIter("abc"))); //RuntimeError WHY?
    System.out.println(permutations3(mkStringIter("abc"))); //RuntimeError WHY?   
 }
}