package haskell.parsLib;
import haskell.data.*;
import haskell.data.functions.*;

import static haskell.data.Iterables.*;

public interface Parser<T,R>{
  Iterable<Tuple2<R,Iterable<T>>> parse(Iterable<T> xs);

  Parser<T,R> alt(Parser<T,R> p2) default{
    Parser<T,R> dieser = this;
    return (xs)-> append(dieser.parse(xs),p2.parse(xs));
  }

  <R2> Parser<T,Tuple2<R,R2>> seq(Parser<T,R2> p2) default{
    Parser<T,R> dieser = this;
    return (xs)->{
      Iterable<Tuple2<R,Iterable<T>>> ergs1 = dieser.parse(xs);
      return 
        concat(  
	  Iterables.map
           ((erg1)->Iterables.map((erg2)->new Tuple2<>(new Tuple2<>(erg1.e1,erg2.e1),erg2.e2),p2.parse(erg1.e2)),ergs1));
    };
  }
  <R2> Parser<T,R2> map(Function1<R,R2> f) default{
    Parser<T,R> dieser = this;
    return (xs)-> Iterables.map((erg1)->new Tuple2<R2,Iterable<T>>(f.eval(erg1.e1),erg1.e2),dieser.parse(xs));
  }

  Parser<T,Iterable<R>> oneToMany() default{
    Parser<T,R> dieser = this;
    return (xs) -> dieser.seq(dieser.oneToMany()).map((res)->cons(res.e1,res.e2))
    	.alt(dieser.map((x)->cons(x,new Nil<R>()))).parse(xs);
  }
  Parser<T,Iterable<R>> zeroToMany() default{
    Parser<T,R> dieser = this;
    return (xs) -> cons(new Tuple2<Iterable<R>,Iterable<T>>(new Nil<R>(),xs),dieser.oneToMany().parse(xs));
  }

}