package haskell.parsLib.test;

import haskell.parsLib.*;
import java.util.*;
import haskell.data.*;
import haskell.data.functions.*;

import static haskell.data.Iterables.*;
import static haskell.parsLib.Parsers.*;

public class SimpleTests{
  public static <A> List<A> mkList(A... as){
    List<A> result = new LinkedList<A>();
    for (A a:as) result.add(a);
    return result;
  }

  public static void main(String  [] args){
    Parser<String,String> hello = token("hallo");
    Parser<String,String> world = token("welt");
    Parser<String,String> helloOrWorld = hello.alt(world);
    Parser<String,Tuple2<String,String>> helloThenWorld = hello.seq(world);
    Parser<String,String> helloThenWorldString = helloThenWorld.map((xy)->xy.e1+" "+xy.e2);
    Iterable<String> xs 
      = mkList("hallo","welt","dieses","ist","ein","Test","wie","geht","es","dir");
    System.out.println(hello.parse(xs));
    System.out.println(world.parse(xs));
    System.out.println(helloOrWorld.parse(xs));
    System.out.println(helloThenWorld.parse(xs));
    System.out.println(helloThenWorldString.parse(xs));
    Iterable<String> ys 
      = mkList("hallo","welt","hallo","welt","hallo","welt","hallo","welt","dieses","ist","ein","Test","wie","geht","es","dir");
    System.out.println(helloThenWorldString.oneToMany().parse(ys));
    System.out.println(helloThenWorldString.zeroToMany().parse(ys));
  }
}